=== src/binaryen/src/cfg/CMakeLists.txt ===
SET(cfg_SOURCES
  Relooper.cpp
)
ADD_LIBRARY(cfg STATIC ${cfg_SOURCES})
