=== src/binaryen/src/passes/CMakeLists.txt ===
SET(passes_SOURCES
  pass.cpp
  CoalesceLocals.cpp
  CodePushing.cpp
  CodeFolding.cpp
  ConstHoisting.cpp
  DeadCodeElimination.cpp
  DuplicateFunctionElimination.cpp
  ExtractFunction.cpp
  Flatten.cpp
  Inlining.cpp
  LegalizeJSInterface.cpp
  LocalCSE.cpp
  LogExecution.cpp
  I64ToI32Lowering.cpp
  InstrumentLocals.cpp
  InstrumentMemory.cpp
  MemoryPacking.cpp
  MergeBlocks.cpp
  Metrics.cpp
  NameList.cpp
  OptimizeInstructions.cpp
  PickLoadSigns.cpp
  PostEmscripten.cpp
  Precompute.cpp
  Print.cpp
  PrintCallGraph.cpp
  RelooperJumpThreading.cpp
  ReReloop.cpp
  RemoveImports.cpp
  RemoveMemory.cpp
  RemoveUnusedBrs.cpp
  RemoveUnusedNames.cpp
  RemoveUnusedModuleElements.cpp
  ReorderLocals.cpp
  ReorderFunctions.cpp
  TrapMode.cpp
  SafeHeap.cpp
  SimplifyLocals.cpp
  SSAify.cpp
  Untee.cpp
  Vacuum.cpp
)
ADD_LIBRARY(passes STATIC ${passes_SOURCES})
