=== debian/changelog ===
rustc (1.24.1+dfsg1+llvm-0ubuntu2) bionic; urgency=medium

  * Build LLVM with large file support so that we can compile rustc 1.25 on
    32-bit architectures
    - update debian/rules

 -- Chris Coulson <chris.coulson@canonical.com>  Thu, 12 Apr 2018 19:48:18 +0100

rustc (1.24.1+dfsg1+llvm-0ubuntu1) bionic; urgency=medium

  [ Chris Coulson / Rico Tzschichholz ]
  * Merge from Debian unstable, remaining changes:
    - Use the bundled llvm to avoid having to do llvm updates in order to
      deliver rust updates
      - update debian/config.toml.in
      - update debian/control
      - update debian/copyright
      - update debian/rules
    - Don't run dynamic_lib::tests::test_loading_cosine on Aarch64 whilst if
      fails there
      - add debian/patches/u-ignoretest-arm64_02.patch
      - update debian/patches/series
    - Make test failures fatal, except on ppc64el and s390x, as there's nothing
      in the archive yet that requires a working rust on these architectures
      - update debian/rules
    - Disable debuginfo when building on 32-bit architectures, as it seems to
      be the only way we can get a successful build
      - update debian/config.toml.in
      - update debian/rules
    - Ensure the build uses the bundled stage0 rustc when bootstrapping
      - update debian/config.toml.in
      - update debian/rules
    - Add a hack to ensure the stage0 compiler is extracted to the correct
      location
      - update debian/make_orig-stage0_tarball.sh

 -- Chris Coulson <chris.coulson@canonical.com>  Fri, 16 Mar 2018 02:16:14 +0000

rustc (1.23.0+dfsg1+llvm-0ubuntu2) bionic; urgency=medium

  * Merge from Debian experimental, remaining changes:
    - Use the bundled llvm to avoid having to do llvm updates in order to
      deliver rust updates
      - update debian/config.toml.in
      - update debian/control
      - update debian/copyright
      - update debian/rules
    - Don't run dynamic_lib::tests::test_loading_cosine on Aarch64 whilst if
      fails there
      - add debian/patches/u-ignoretest-arm64_02.patch
      - update debian/patches/series
    - Make test failures fatal, except on ppc64el and s390x, as there's nothing
      in the archive yet that requires a working rust on these architectures
      - update debian/rules
    - Disable debuginfo when building on 32-bit architectures, as it seems to
      be the only way we can get a successful build
      - update debian/config.toml.in
      - update debian/rules
    - Update debian/patches/u-make-tests-work-without-rpath.patch to fix some
      test failures
    - Backport an upstream change to make the stack overflow detection work
      with a recent change in glibc 2.27 that moves the stack guard page for
      threads beyond the end of the stack
      - add debian/patches/u-stack-guard-glibc-2.27-fix.patch
      - update debian/patches/series    

 -- Chris Coulson <chris.coulson@canonical.com>  Thu, 01 Feb 2018 13:59:02 +0000
